# Copyright 2021-2022 Datum Technology Corporation
# SPDX-License-Identifier: Apache-2.0 WITH SHL-2.1


main_help_text = """
                              ███╗   ███╗ ██████╗  ██████╗ ██████╗ ███████╗   ██╗ ██████╗
                              ████╗ ████║██╔═══██╗██╔═══██╗██╔══██╗██╔════╝   ██║██╔═══██╗
                              ██╔████╔██║██║   ██║██║   ██║██████╔╝█████╗     ██║██║   ██║
                              ██║╚██╔╝██║██║   ██║██║   ██║██╔══██╗██╔══╝     ██║██║   ██║
                              ██║ ╚═╝ ██║╚██████╔╝╚██████╔╝██║  ██║███████╗██╗██║╚██████╔╝
                              ╚═╝     ╚═╝ ╚═════╝  ╚═════╝ ╚═╝  ╚═╝╚══════╝╚═╝╚═╝ ╚═════╝
                                 Moore.io (`mio`) Command Line Interface (CLI) - v1.2.0
                             User Manual: https://readthedocs.org/projects/mooreio-client/

              https://mooreio.org - Copyright 2021-2022 Datum Technology Corporation - https://datumtc.ca
Usage:
  mio [--version] [--help]
  mio [--wd=<path>] [--dbg] <command> [<args> ...]

Options:
  -v, --version
    Prints the mio version and exits.
  
  -h, --help
    Prints the overall synopsis and a list of the most commonly used commands and exits.
  
  --list-commands
    Prints a list of all mio commands and exits.
  
  --html-path
    Opens Firefox to the Moore.io CLI Client user manual.
    
  -C <path>, --wd=<path>
    Run as if mio was started in <path> instead of the current working directory.
   
  --dbg
    Enables debugging and tracing outputs from mio.

Full Command List:
   Project and Environment Management
      init           Starts project creation dialog
      new            Creates new source code via the mio template engine
   
   IP and Credentials Management
      install        Install all IP dependencies
   
   Automate Moore.io, F&OS and Vendor EDA Tools
      sim            Performs necessary steps to simulate an IP
      regr           Run regression against an IP
      dox            HDL source code documentation generation via Doxygen
      
   Manage Results and other EDA Tool Outputs
      results        Manages results from EDA tools
      cov            Manages coverage data from EDA tools
      clean          Manages outputs from tools (other than job results)
"""






sim_help_text = """
Moore.io Sim(ulation) Command
   Performs necessary steps to run simulation of an IP. Supports Digital and Mixed-Signal (AMS) Simulation.
   
   While the controls for individual steps (library creation, compilation, elaboration and simulation) are exposed, it
   is recommended to let `mio sim` manage this process as much as possible.  In the unlikely event of corrupt and/or
   locked simulator artifacts, see `mio clean`.  Combining any of the step-control arguments (-F, -C, -E, -S) with
   missing steps can result in unpredictable behavior and is not recommended (ex: `-FS`).
   
   Parameters (`<params>`) are parsed by mio which performs the conversions to specific vendor tool arguments, as
   specified by IP metadata (`ip.yml`) and the Configuration Database (`.mio.toml`).  Parameters that are not
   recognized are passed untouched to the end executable, along with all Tool Arguments (`<args>`).
   
Usage:
   mio sim <ip> [options] [-- <hdl_args>] [--- <tool_args>]  Runs specific simulation
   
Options:
   -t <name>      , --test=<name>         Specifies UVM test name.
   -s <integer>   , --seed=<integer>      Specifies simulation seed.  A random one will be chosen if not specified.
   -v <level>     , --verbosity=<level>   Specifies UVM verbosity level.
   -w             , --waves               Captures simulation waveforms.
   -c             , --cov                 Enales functional and code coverage.
   -a <name>      , --app=<name>          Specifies simulator application (viv, mtr, vcs, xcl, qst, riv).
   -g             , --gui                 Invokes simulator in graphical or 'GUI' mode.
   
   -S   Force mio to simulate  target IP.  Can be combined with -C and/or -E.
   -E   Force mio to elaborate target IP.  Can be combined with -C and/or -S.
   -C   Force mio to compile   target IP.  Can be combined with -E and/or -S.
   -F   Force mio to invoke FuseSoC on core file(s).
   
   -q          , --quiet               Mutes simulator output to stdout.
   -b          , --batch-mode          Runs simulations in parallel (usually combined with --repeat).
   -r <integer>, --repeat=<integer>    Specifies number of simulation repeats. [default: 1]
   -p <path>   , --results-dir=<path>  Specifies results directory path.  A symlink is created in the local results.
Examples:
   mio sim --test=my_test --seed=42 --verbosity=high    # Simulate Default IP with specific test, seed and verbosity
   mio sim -l bug35 -f ./bug35.mlist                    # Simulate using m-list file and a simulation label
   mio sim my_ip -CE -- dp-width=32B --- --permissive   # Compile and elaborate specific IP with IP parameter and tool
                                                          argument
   mio sim some_ip -t my_test -a vcs -x dbg_sigs.tcl    # Run a specific test with VCS and a specific TCL script
   mio sim -S -t my_test -s 1 --waves='/my_block/*'     # Only simulate a specific test, seed with custom wave capture
   mio sim -a nc -n ./bin/latest.sv --sdf=default.sdf   # Simulate specific design netlist with specific delays with NC
   mio sim my_ip -t my_test -b --repeat=10 --cov=*      # Simulate a specific IP and test 10 times in parallel with
                                                          random seeds and all coverage types being collected
   mio sim ! -m > ./bug35.mlist                         # Create mlist file to reproduce simulation elsewhere with mio
   mio sim @my_scope/my_ip -a vcs -Cd > ./ip.vcs.flist  # Create filelist to reproduce simulation outside mio
"""







regr_help_text = """
Moore.io Regr(ession) Command
   Executes regression(s) against a target IP.
   
Usage:
   mio regr [[@<scope>/]<ip>] <regression> ... [options] [-- <params>] [--- <args>]  Runs regression(s) against IP
   mio regr [@<scope>/]<ip>/<regression>   ... [options] [-- <params>] [--- <args>]  Runs regression(s) against IP(s)
   mio regr !                                  [options] [-- <params>] [--- <args>]  Re-runs last regr command
Options:
   -f <path>   , --m-file=<path>       Specifies mlist from which to load mio, tool arguments and IP parameters
   -e <address>, --email=<address>     Specifies email address(es) (comma separated) to contact with regression results.
   -l <string> , --label=<string>      Specifies results label.  Used as a prefix/suffix in file and/or directory names.
   -q          , --quiet               Mutes timing analysis tool output to stdout.
   -p <path>   , --results-dir=<path>  Specifies results directory path.  A symlink is created in the local results.
   -d          , --dry-run             Only Prints the commands mio would normally execute to perform timing analysis.
   -m          , --m-run               Only prints the mlist file contents for the mio command.
   
Examples:
   mio regr sanity                               # Run specific regression against Default IP
   mio regr ! -q -- dp-width=64B                 # Re-run last regression with additional parameters and no output
   mio regr -f sanity_mod.mlist -f b34.mlist     # Run two regressions from mlists in parallel
   mio regr @my_scope/my_ip nightly              # Run specific regression against specific IP
   mio regr nightly -f P2.mlist -- multiplier=1  # Run specific regression against specific IP with mixed parameters
   mio regr client_1_bugs client_2_features      # Launch multiple regressions in parallel against Default IP
   mio regr my_ip/sanity some_ip/nightly         # Launch multiple regressions in parallel against multiple IPs
   mio regr ! -m > ./my_regr.mlist               # Save last regression command to disk
"""



